



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>好用的前端页面性能检测工具—sitespeed.io</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">好用的前端页面性能检测工具—sitespeed.io</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-08 19:32:26 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><!--?xml version="1.0" encoding="UTF-8"?--></p>
<h2>引言</h2>
<div>最近在做HTTP2技术相关调研，想确认一下HTTP2在什么情境下性能会比HTTP1.x有显著提升，当我把http2的本地环境（nginx+PHP）部署完成后进行相关测试时，我遇到了以下问题：</div>
<div><strong>（1）平时使用的都是在线分析工具，如google的<a href="https://developers.google.com/speed/pagespeed/insights/" rel="external nofollow noreferrer">PageSpeed Insights</a>和<a href="https://gtmetrix.com/analyze.html" rel="external nofollow noreferrer">GTmetrix</a>，这些工具无法提供线下测试环境；</strong></div>
<div><strong>（2）自己通过chrome dev-tool的Perfomance进行分析，需要手动刷新，并手动记录，需要大量的重复工作，尤其是要控制变量测试的情况；</strong></div>
<div><strong>（3）通过代码打log，即通过performance.timing中记录的TimeEvent时刻计算页面性能指标，指标的完整性和图形化展示仍需要工作量；</strong></div>
<div><strong>（4）能否在真机上测试，现在都是在PC上模拟。</strong></div>
<div>于是就想着能否有一个工具能够调起浏览器，利用浏览器debug面板中的各种数据（请求、事件等）为用户提供页面性能分析结果，最好能图形化或表格展示。检索了一下，发现了<a href="https://www.sitespeed.io/" rel="external nofollow noreferrer">sitespeed.io</a>这个开源工具，基本符合我的预期，这里跟大伙分享一下这个工具。&nbsp;</div>
<h2>sitespeed.io相关介绍</h2>
<h3>sitespeed.io的产出</h3>
<div>介绍sitespeed.io之前，先看看sitespeed.io的产出。</div>
<div>安装sitespeed.io之后，如果要分析一下百度PC首页性能，执行以下命令：</div>
<div>&nbsp;</div>
<div>
<div>
<pre class="prettyprint linenums">sitespeed.io  -n  -v https://www.baidu.com</pre>
</div>
<p>该命令将会在chrome浏览器下调起URL为https://www.baidu.com 5次，产出了一个分析文件夹，文件夹下载请戳<a href="https://github.com/huangwenming/demos/tree/master/sitespeed-result/www.baidu.com/2017-09-29-16-32-46" rel="external nofollow noreferrer">这里</a>：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/605230/201710/605230-20171002141550130-256954487.png" /></p>
<p>打开index.html文件后，我们可以看到关于页面性能的相关总结。</p>
<p><em><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/605230/201710/605230-20171002141811005-632268066.png" /></em></p>
<p>页面性能总结</p>
<p><em><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/605230/201710/605230-20171002170750068-1379235906.png" /></em></p>
<p>页面相关意见</p>
<p>我们可以看到该工具围绕：页面性能（Performance）、Web最佳实践（Web Best Practice）和可用性（Accessibility）三个核心指标进行打分，每个核心指标考核的内容可以在help.html文件中查找。页面中的其他指标，如文件压缩、文件大小、请求数、缓存时间、请求状态码、首次渲染时间、前端渲染用时、页面加载用时、DNS解析时长等，这些指标都有详细的统计，而且不同等级用相应的颜色表示，基本满足我的诉求。</p>
<h3>sitespeed.io的工作原理</h3>
<p>sitespeed.io是一个开源工具，旨在检测和提高web页面的性能。它拥有一套插件，如<a href="https://www.sitespeed.io/documentation/coach/" rel="external nofollow noreferrer">Coach</a>、<a href="https://www.sitespeed.io/documentation/browsertime/" rel="external nofollow noreferrer">Broswertime</a>、<a href="https://github.com/sitespeedio/chrome-har" rel="external nofollow noreferrer">Chrome-HAR</a>等，帮助sitespeed搜集浏览器debug状态下的数据，并基于网站最佳实践给出相应的打分和意见，最后把数据可视化展示。</p>
<p>sitespeed.io评价网页的主要依据是：浏览器的网络请求和TimeLine中的Time Event。</p>
<p>Browsertime插件会使用Selenium NodeJS操控浏览器，让浏览器加载指定的页面，并执行配置的JS代码，采集Timeline中各个Time Event触发的时间数据，同时借助Chrome-HAR插件把页面中HTTP请求过程存储在.har文件中，为了便于分析，sitespeed.io利用<a href="https://www.sitespeed.io/documentation/pagexray/" rel="external nofollow noreferrer">PageXray</a>插件将.har文件转换成JSON文件；然后Coach插件根据相应的指标进行打分，并提出改进意见。总的来说，sitespeed.io的工作原理如下图所示。</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/605230/201710/605230-20171002171009083-1137117296.png" /></p>
<p>sitespeed.io工作原理图</p>
<p>由于接触sitespeed.io的时间比较短，目前积累比较少，这次仅做个简单的分享，希望更多前端的小伙伴能够接触并使用该工具，写出高性能的页面。</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq44od0q.html">Java 实现文件上传、下载、打包、文件copy、文件夹copy。</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2gd0l8.html">安装pillow错误的解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jro5lq.html">3&period;js模式-策略模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mo6z69.html">iOS 拉伸图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1g1g6q.html">canvas的代码封装</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnjlm6q.html">Zend Studio GitHub 使用教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnwr42q.html">设计模式（Design Patterns&mdash;&mdash;可复用面向对象软件的基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj2y7z9.html">java&period;lang&period;ExceptionInInitializerError的原因（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmylnl9.html">除法（Division &comma;UVA 725）-ACM集训</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1g7r59.html">图解MonoForAndroid开发环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjn1dj8.html">论移动端Hybid开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey2mmz9.html">51 Nod 1057 N的阶乘【Java大数乱搞】</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge2v508.html">selenium2 run in Jenkins GUI testing not visible or browser not open but run in background浏览器后台运行不可见</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p1k3j8.html">5组I&sol;O函数的比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj0oo39.html">前端&mdash;&mdash;BOM和DOM</a>
		</li>
						<li><a href="https://www.batexi.com/a/960jg249.html">redhat 7 配置源</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jye6nq.html">&lbrack;STM32F103&rsqb;定时器中断</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv217ey9.html">Flipping an Image</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv270py9.html">url字符长度限制解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kojzejq.html">update关联其他表批量更新数据-跨数据库-跨服务器Update时关联表条件更新</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9jzv1448.html">Java基础---网络编程</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rg6nzr8.html">Python&plus;Requests接口测试教程（2）：</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oj345eq.html">sqlplus命令历史解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjgnr38.html">HDMI转MIPI DSI芯片方案TC358779XBG</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m4dko8.html">&lbrack;小北De编程手记&rsqb; &lbrack;Lesson 02&rsqb; AutoFramework构建 之 Page Objects - 设计模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk6lre8.html">WPF依赖属性2</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpgzw7q.html">AT&amp;T汇编语言学习：利用c库、文件读写</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey3r0x9.html">201521123093  java  第七周学习总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpkrdr9.html">201521123016《Java设计与程序》第6周学习总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzvxnw8.html">201521145《Java程序设计》第2周学习总结</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
